/*  Kanni IME Transliteration Javascript Library
 *  Copyright (c) 2012 http://tamilnanbargal.com
 *  
 *  Some part of the language mappings are copied from Gopi's Unicode Converter(http://www.higopi.com)
 *  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 * Dual licensed under the MIT and GPL licenses:
 *   http://www.opensource.org/licenses/mit-license.php
 *   http://www.gnu.org/licenses/gpl.html
 *
 * Further to the terms mentioned you should leave this copyright notice
 * intact, stating me as the original author.
**/

Kanni['languages']['hindi'] = {
  'name' : "Hindi",      // language Name
  'charfrom' : '0900',
  'charto' : '097F',
  'chnbin' : "\u094D",
  'ugar' : "\u0941",
  'uugar' : "\u0942",
  'methods' : {
    'hi_tw' : {
      'method' : 'typewriter',   // typing method
      'maxchar' : '4',           // maximum char combination
      'mergeprevchar' : false,  // merge with previous char?
      'charmap' : {
        '\\!' : '\u090D',
        '\\@' : '\u0945',
        '\\#' : '\u094D\u0930',
        '\\$' : '\u0930\u094D',
        '\\%' : '\u091C\u094D\u091E',
        '\\^' : '\u0924\u094D\u0930',
        '\\&' : '\u0915\u094D\u0937',
        '\\*' : '\u0936\u094D\u0930',
        '_' : '\u0903',
        '\\+' : '\u090B',
        '\\=' : '\u0943',
        'q' : '\u094C',
        'w' : '\u0948',
        'e' : '\u093E',
        'r' : '\u0940',
        't' : '\u0942',
        'y' : '\u092C',
        'u' : '\u0939',
        'i' : '\u0917',
        'o' : '\u0926',
        'p' : '\u091C',
        '\\[' : '\u0921',
        '\\]' : '\u093C',
        'Q' : '\u0914',
        'W' : '\u0910',
        'E' : '\u0906',
        'R' : '\u0908',
        'T' : '\u090A',
        'Y' : '\u092D',
        'U' : '\u0919',
        'I' : '\u0918',
        'O' : '\u0927',
        'P' : '\u091D',
        '\\{' : '\u0922',
        '\\}' : '\u091E',
        'a' : '\u094B',
        's' : '\u0947',
        'd' : '\u094D',
        'f' : '\u093F',
        'g' : '\u0941',
        'h' : '\u092A',
        'j' : '\u0930',
        'k' : '\u0915',
        'l' : '\u0924',
        ';' : '\u091A',
        '\\\'' : '\u091F',
        '\\\\' : '\u0949',
        'A' : '\u0913',
        'S' : '\u090F',
        'D' : '\u0905',
        'F' : '\u0907',
        'G' : '\u0909',
        'H' : '\u092B',
        'J' : '\u0931',
        'K' : '\u0916',
        'L' : '\u0925',
        ':' : '\u091B',
        '"' : '\u0920',
        '\\|' : '\u0911',
        'z' : '',
        'x' : '\u0902',
        'c' : '\u092E',
        'v' : '\u0928',
        'b' : '\u0935',
        'n' : '\u0932',
        'm' : '\u0938',
        '/' : '\u092F',
        'Z' : '',
        'X' : '\u0901',
        'C' : '\u0923',
        'V' : '',
        'B' : '',
        'N' : '\u0933',
        'M' : '\u0936',
        '<' : '\u0937',
        '>' : '\u0964',
        '\\?' : '\u095F'
      }
    },
    'hi_en' : {
      'method' : 'phonetic',
      'maxchar' : '4',
      'mergeprevchar' : true,
      'charmap' : {
        'B' : 'b',
        'C' : 'c',
        'F' : 'ph',
        'f' : 'ph',
        'G' : 'g',
        'J' : 'j',
        'K' : 'k',
        'M' : 'm',
        'P' : 'p',
        'Q' : 'q',
        'V' : 'v',
        'W' : 'v',
        'w' : 'v',
        'X' : 'x',
        'Y' : 'y',
        'Z' : 'z',
        'k' : '\u0915\u094D', //Cons
        'c' : '\u091A\u094D',
        'T' : '\u091F\u094D',
        'D' : '\u0921\u094D',
        'N' : '\u0923\u094D',
        't' : '\u0924\u094D',
        'd' : '\u0926\u094D',
        'p' : '\u092A\u094D',
        'b' : '\u092C\u094D',
        'y' : '\u092F\u094D',
        'R' : '\u0931\u094D',
        'L' : '\u0933\u094D',
        'v' : '\u0935\u094D',
        's' : '\u0938\u094D',
        'S' : '\u0937\u094D',
        'H' : '\u0939\u094D',
        'x' : '\u0915\u094D\u0936\u094D',
        '\u200Dn' : '\u0901',
        '\u200Dm' : '\u0902',
        'm' : '\u092E\u094D',
        'n' : '\u0928\u094D',
        ':h' : '\u0903',
        '\u0928\u094D\\.' : '\u0929\u094D',
        '\u0930\u094D\\.' : '\u0931\u094D',
        'q' : '\u0958\u094D',
        '\u0915\u094D\\.' : '\u0958\u094D',
        '\u0916\u094D\\.' : '\u0959\u094D',
        '\u0917\u094D\\.' : '\u095A\u094D',
        'z' : '\u095B\u094D',
        '\u0921\u094D\\.' : '\u095C\u094D',
        '\u0922\u094D\\.' : '\u095D\u094D',
        '\u092B\u094D\\.' : '\u095E\u094D',
        '\u092F\u094D\\.' : '\u095F\u094D',
        '\u0915\u094Dh' : '\u0916\u094D',
        '\u0917\u094Dh' : '\u0918\u094D',
        '\u0928\u094Dg' : '\u0919\u094D',
        '\u091A\u094Dh' : '\u091B\u094D',
        '\u091C\u094Dh' : '\u091D\u094D',
        '\u0928\u094Dj' : '\u091E\u094D',
        '\u091F\u094Dh' : '\u0920\u094D',
        '\u0921\u094Dh' : '\u0922\u094D',
        '\u0924\u094Dh' : '\u0925\u094D',
        '\u0926\u094Dh' : '\u0927\u094D',
        '\u092A\u094Dh' : '\u092B\u094D',
        '\u092C\u094Dh' : '\u092D\u094D',
        '\u0938\u094Dh' : '\u0936\u094D',
        '\u0931\u094Dr' : '\u090B',
        '\u0933\u094Dl' : '\u090C',
        '\u094D\u090B' : '\u0943',
        '\u0913\u092E\u094D' : '\u0950',
        'r' : '\u0930\u094D',
        'l' : '\u0932\u094D',
        'h' : '\u0939\u094D',
        'g' : '\u0917\u094D',
        'j' : '\u091C\u094D',
        '\u094Da' : '\u200C', //VowSml
        '\u094Di' : '\u093F',
        '\u094Du' : '\u0941',
        '\u094De' : '\u0946',
        '\u094Do' : '\u094A',
        '\u200Ci' : '\u0948',
        '\u200Cu' : '\u094C',
        '\u200C-' : '\u200D',
        '\u200C:' : ':',
        '-' : '\u200D',
        '\u200Ca' : '\u093E', //VowBig
        '\u093Fi' : '\u0940',
        '\u0941u' : '\u0942',
        '\u0946e' : '\u0947',
        '\u094Ao' : '\u094B',
        '\u094DA' : '\u093E',
        '\u094DI' : '\u0940',
        '\u094DU' : '\u0942',
        '\u094DE' : '\u0947',
        '\u094DO' : '\u094B',
        '\u0905i' : '\u0910', //Vows
        '\u0905u' : '\u0914',
        '\u0905a' : '\u0906',
        '\u0907i' : '\u0908',
        '\u0909u' : '\u090A',
        '\u090Ee' : '\u090F',
        '\u0912o' : '\u0913',
        '\u0913m' : '\u0950',
        'a' : '\u0905',
        'A' : '\u0906',
        'i' : '\u0907',
        'I' : '\u0908',
        'u' : '\u0909',
        'U' : '\u090A',
        'e' : '\u090E',
        'E' : '\u090F',
        'o' : '\u0912',
        'O' : '\u0913',
        '\u200D1' : '\u0967', //Nums
        '\u200D2' : '\u0968',
        '\u200D3' : '\u0969',
        '\u200D4' : '\u096A',
        '\u200D5' : '\u096B',
        '\u200D6' : '\u096C',
        '\u200D7' : '\u096D',
        '\u200D8' : '\u096E',
        '\u200D9' : '\u096F',
        '\u200D0' : '\u0966',
        '(.+)\u200C(.+)' : '$1$2'

      }
    },
    'hi_tw_re' : {
      'method' : 'Remington',
      'maxchar' : '4',
      'mergeprevchar' : true,
      'charmap' : {
        '\u200D1' : '\u0967',
        '\u200D2' : '\u0968',
        '\u200D3' : '\u0969',
        '\u200D4' : '\u096A',
        '\u200D5' : '\u096B',
        '\u200D6' : '\u096C',
        '\u200D7' : '\u096D',
        '\u200D8' : '\u096E',
        '\u200D9' : '\u096F',
        '\u200D0' : '\u0966',
        '\~' : '\u0943',
        '\\!' : '\u090D',
        '\\@' : '\u0945',
        '\\#' : '\u0930\u0941',
        '\\$' : '\u002B',
        '\\%' : '\u0903',
        '\\^' : '\u0027',
        '\\&' : '\u005F',
        '\\*' : '\u0936\u094D\u0930',
        '_' : '\u090B',
        '\\+' : '\u093C',
        '\\=' : '\u0924\u094D\u0930',
        'q' : '\u0941',
        'w' : '\u0942',
        'e' : '\u092E',
        'r' : '\u0924',
        't' : '\u091C',
        'y' : '\u0932',
        'u' : '\u0928',
        'i' : '\u092A',
        'o' : '\u0935',
        'p' : '\u091A',
        '\\[' : '\u0916\u094D',
        '\\]' : '\u002C',
        'Q' : '\u092B',
        'W' : '\u0945',
        'E' : '\u092E\u094D',
        'R' : '\u0908',
        'T' : '\u091C\u094D',
        'Y' : '\u0932\u094D',
        'U' : '\u0928\u094D',
        'I' : '\u092A\u094D',
        'O' : '\u0935\u094D',
        'P' : '\u091A\u094D',
        '\\{' : '\u0915\u094D\u0937',
        '\\}' : '\u0926\u094D\u0930',
        '\\(' : '\u003B',
        '\\)' : '\u0926\u094D\u0927',
        'a' : '\u0902',
        's' : '\u0947',
        'd' : '\u0915',
        'f' : '\u093F',
        'g' : '\u0939',
        'h' : '\u0940',
        'j' : '\u0930',
        'k' : '\u093E',
        'l' : '\u0938',
        ';' : '\u092F',
        '\\\'' : '\u0936\u094D',
        //'\\\\' : '\u0936\u094D',
        'A' : '\u0964',
        'S' : '\u0948',
        'D' : '\u0915\u094D',
        'F' : '\u0925\u094D',
        'G' : '\u0933',
        'H' : '\u092D\u094D',
        'J' : '\u0936\u094D\u0930',
        'K' : '\u091C\u094D\u091E',
        'L' : '\u0938094D',
        ':' : '\u09300941',
        '"' : '\u0937094D',
        '\\|' : '\u0926\u094D\u092F',
        'z' : '',
        'x' : '\u0917',
        'c' : '\u092C',
        'v' : '\u0905',
        'b' : '\u0907',
        'n' : '\u0926',
        'm' : '\u0909',
        '/' : '\u0927\u094D',
        'Z' : '\u0930\u094D',
        'X' : '\u0917\u094D',
        'C' : '\u092C\u094D',
        'V' : '\u091F',
        'B' : '\u0920',
        'N' : '\u091B',
        'M' : '\u0921',
        '<' : '\u0922',
        '>' : '\u091D',
        '\\?' : '\u0918\u094D',
        '\\,' : '\u090F',
        '\\.' : '\u0923\u094D'
      }
    }
  }
};

