/*  Kanni IME Transliteration Javascript Library
 *  Copyright (c) 2012 http://tamilnanbargal.com
 *
 *  Some part of the language mappings are copied from Gopi's Unicode Converter(http://www.higopi.com)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 * Dual licensed under the MIT and GPL licenses:
 *   http://www.opensource.org/licenses/mit-license.php
 *   http://www.gnu.org/licenses/gpl.html
 *
 * Further to the terms mentioned you should leave this copyright notice
 * intact, stating me as the original author.
**/

Kanni['languages']['tamil'] = {
  'name' : "Tamil",       // language Name
  'charfrom' : '0B80',
  'charto' : '0BFF',
  'charextra' : {},       // extra chars
  'methods' : {
    'ta_tw' : {
      'method' : 'typewriter',   // typing method
      'maxchar' : '4',           // maximum char combination
      'mergeprevchar' : false,  // merge with previous char?
      'charmap' : {
        '\\!' : "\u0BB8",
        '\\$' : "\u0B9C",
        '\\%' : "\u0BC1",
        '\\^' : "\u0BC2",
        '\\&' : "\u0BB7",
        '_' : "\u0BB8\u0BCD\u0BB0\u0BC0",
        'q' : "\u0BA3\u0BC1",
        'w' : "\u0BB1",
        'e' : "\u0BA8",
        'r' : "\u0B9A",
        't' : "\u0BB5",
        'y' : "\u0BB2",
        'u' : "\u0BB0",
        'i' : "\u0BC8",
        'o' : "\u0B9F\u0BBF",
        'p' : "\u0BBF",
        '\\[' : "\u0BC1",
        '\\]' : "\u0B94",
        "\\\\" : "\u0B95\u0BCD\u0BB7",
        'Q' : "\u0B9E\u0BC1",
        'W' : "\u0BB1\u0BC1",
        'E' : "\u0BA8\u0BC1",
        'R' : "\u0B9A\u0BC1",
        'T' : "\u0B95\u0BC2",
        'Y' : "\u0BB2\u0BC1",
        'U' : "\u0BB0\u0BC1",
        'I' : "\u0B90",
        'O' : "\u0B9F\u0BC0",
        'P' : "\u0BC0",
        '\\{' : "\u0BC2",
        '\\}' : "\u0BC2",
        'a' : "\u0BAF",
        's' : "\u0BB3",
        'd' : "\u0BA9",
        'f' : "\u0B95",
        'g' : "\u0BAA",
        'h' : "\u0BBE",
        'j' : "\u0BA4",
        'k' : "\u0BAE",
        'l' : "\u0B9F",
        '\\,' : "\u0BCD",
        '\\\'' : "\u0B99",
        'A' : "\u0BB1\u0BBE",
        'S' : "\u0BB3\u0BC1",
        'D' : "\u0BA9\u0BC1",
        'F' : "\u0B95\u0BC1",
        'G' : "\u0BB4\u0BC1",
        'H' : "\u0BB4",
        'J' : "\u0BA4\u0BC1",
        'K' : "\u0BAE\u0BC1",
        'L' : "\u0B9F\u0BC1",
        '\\:' : "\u00B0",
        '\\"' : "\u0B9E",
        'z' : "\u0BA3",
        'x' : "\u0B92",
        'c' : "\u0B89",
        'v' : "\u0B8E",
        'b' : "\u0BC6",
        'n' : "\u0BC7",
        'm' : "\u0B85",
        ',' : "\u0B87",
        'Z' : "\u0BB9",
        'X' : "\u0B93",
        'C' : "\u0B8A",
        'V' : "\u0B8F",
        'B' : "\u0B83",
        'N' : "\u0B9A\u0BC2",
        'M' : "\u0B86",
        '\\<' : "\u0B88",
        '\\|' : "!",
        '\\`' : "&",
        '\\.' : ",",
        '/' : ".",
        '\\#' : "%",
        '\\~' : ",",
        '-' : "/",
        '\\@' : "\"",
        '\\>' : "-",
        '\u0BC1\u0BC2' : "\u0BC2"
      }
    },
    'ta_en' : {
      'method' : 'phonetic',
      'maxchar' : '4',
      'mergeprevchar' : true,
      'charmap' : {
        'f' : "qp",
        'B' : "b",
        'C' : "c",
        'D' : "d",
        'F' : "qp",
        'G' : "g",
        'H' : "h",
        'J' : "j",
        'K' : "k",
        'M' : "m",
        'P' : "p",
        'Q' : "q",
        'T' : "t",
        'V' : "v",
        'W' : "w",
        'X' : "x",
        'Y' : "y",
        'Z' : "z",
        '\u0BA8\u0BCDg' : "\u0B99\u0BCD",
        '\u0BA9\u0BCDg' : "\u0B99\u0BCD",
        '\u0BA8\u0BCDj' : "\u0B9E\u0BCD",
        '\u0BA9\u0BCDj' : "\u0B9E\u0BCD",
        '\u0B9F\u0BCDh' : "\u0BA4\u0BCD",
        '\u0B9A\u0BCDh' : "\u0BB7\u0BCD",
        '\u0BA9\u0BCD\u0BA4\u0BCD' : "\u0BA8\u0BCD\u0BA4\u0BCD",
        'ng' : "\u0B99\u0BCD",
        'nj' : "\u0B9E\u0BCD",
        'th' : "\u0BA4\u0BCD",
        'sh' : "\u0BB7\u0BCD",
        'k' : "\u0B95\u0BCD",
        'g' : "\u0B95\u0BCD",
        'c' : "\u0B9A\u0BCD",
        's' : "\u0B9A\u0BCD",
        't' : "\u0B9F\u0BCD",
        'd' : "\u0B9F\u0BCD",
        'N' : "\u0BA3\u0BCD",
        ' n' : " \u0BA8\u0BCD",
        '^n' : "\u0BA8\u0BCD",
        '\nn' : "\n\u0BA8\u0BCD",
        'w' : "\u0BA8\u0BCD",
        'p' : "\u0BAA\u0BCD",
        'b' : "\u0BAA\u0BCD",
        'm' : "\u0BAE\u0BCD",
        'y' : "\u0BAF\u0BCD",
        'r' : "\u0BB0\u0BCD",
        'l' : "\u0BB2\u0BCD",
        'v' : "\u0BB5\u0BCD",
        'R' : "\u0BB1\u0BCD",
        'L' : "\u0BB3\u0BCD",
        'z' : "\u0BB4\u0BCD",
        'n' : "\u0BA9\u0BCD",
        'S' : "\u0BB8\u0BCD",
        'h' : "\u0BB9\u0BCD",
        'j' : "\u0B9C\u0BCD",
        'x' : "\u0B95\u0BCD\u0BB7\u0BCD",
        '\u0BCDa' : "\u200C",
        '\u0BCDi' : "\u0BBF",
        '\u0BCDu' : "\u0BC1",
        '\u0BCDe' : "\u0BC6",
        '\u0BCDo' : "\u0BCA",
        '\u200Ci' : "\u0BC8",
        '\u200Cu' : "\u0BCC",
        '\u200Ca' : "\u0BBE",
        '\u0BBFi' : "\u0BC0",
        '\u0BC1u' : "\u0BC2",
        '\u0BC6e' : "\u0BC7",
        '\u0BCAo' : "\u0BCB",
        '\u0BCDA' : "\u0BBE",
        '\u0BCDI' : "\u0BC0",
        '\u0BCDU' : "\u0BC2",
        '\u0BCDE' : "\u0BC7",
        '\u0BCDO' : "\u0BCB",
        '-' : "\u200D",
        '\u0B85i' : "\u0B90",
        '\u0B85u' : "\u0B94",
        'ai' : "\u0B90",
        'au' : "\u0B94",
        '\u0B85a' : "\u0B86",
        '\u0B87i' : "\u0B88",
        '\u0B89u' : "\u0B8A",
        '\u0B8Ee' : "\u0B8F",
        '\u0B92o' : "\u0B93",
        'a' : "\u0B85",
        'A' : "\u0B86",
        'i' : "\u0B87",
        'I' : "\u0B88",
        'u' : "\u0B89",
        'U' : "\u0B8A",
        'e' : "\u0B8E",
        'E' : "\u0B8F",
        'o' : "\u0B92",
        'O' : "\u0B93",
        'q' : "\u0B83",
        '\u0BF10' : "\u0BF2",
        '\u0BF00' : "\u0BF1",
        '\u0BE70' : "\u0BF0",
        '\u200D1' : "\u0BE7",
        '\u200D2' : "\u0BE8",
        '\u200D3' : "\u0BE9",
        '\u200D4' : "\u0BEA",
        '\u200D5' : "\u0BEB",
        '\u200D6' : "\u0BEC",
        '\u200D7' : "\u0BED",
        '\u200D8' : "\u0BEE",
        '\u200D9' : "\u0BEF",
        '\u200D0' : "0",
        '(.+)\u200C(.+)' : "$1$2"
      }
    },
    'ta_99' : {
      'method' : 'ta 99',
      'maxchar' : '4',
      'mergeprevchar' : true,
      'charmap' : {
        '\\^' : "\u200C",
        "\u0B99\u200Ch" : "\u0B99\u0BCD\u0B95\u200C",
        "\u0B9E\u200C\\[" : "\u0B9E\u0BCD\u0B9A\u200C",
        "\u0BA3\u200Co" : "\u0BA3\u0BCD\u0B9F\u200C",
        "\u0BA8\u200Cl" : "\u0BA8\u0BCD\u0BA4\u200C",
        "\u0BAE\u200Cj" : "\u0BAE\u0BCD\u0BAA\u200C",
        "\u0BA9\u200Cu" : "\u0BA9\u0BCD\u0BB1\u200C",
        "\u0BB3\u200Cy" : "\u0BB3\u0BCD\u0BB3\u200D",
        "\u0BB3\u0BCD{2}" : "\u0BB3\u0BCD\u0BB3\u200C",
        "\u0BB1\u200Cu" : "\u0BB1\u0BCD\u0BB1\u200D",
        "\u0BB1\u0BCD{2}" : "\u0BB1\u0BCD\u0BB1\u200C",
        "\u0BA9\u200Ci" : "\u0BA9\u0BCD\u0BA9\u200D",
        "\u0BA9\u0BCD{2}" : "\u0BA9\u0BCD\u0BA9\u200C",
        "\u0B9F\u200Co" : "\u0B9F\u0BCD\u0B9F\u200D",
        "\u0B9F\u0BCD{2}" : "\u0B9F\u0BCD\u0B9F\u200C",
        "\u0BA3\u200Cp" : "\u0BA3\u0BCD\u0BA3\u200D",
        "\u0BA3\u0BCD{2}" : "\u0BA3\u0BCD\u0BA3\u200C",
        "\u0B9A\u200C\\[" : "\u0B9A\u0BCD\u0B9A\u200D",
        "\u0B9A\u0BCD{2}" : "\u0B9A\u0BCD\u0B9A\u200C",
        "\u0B9E\u200C\\]" : "\u0B9E\u0BCD\u0B9E\u200D",
        "\u0B9E\u0BCD{2}" : "\u0B9E\u0BCD\u0B9E\u200C",
        "\u0B95\u200Ch" : "\u0B95\u0BCD\u0B95\u200D",
        "\u0B95\u0BCD{2}" : "\u0B95\u0BCD\u0B95\u200C",
        "\u0BAA\u200Cj" : "\u0BAA\u0BCD\u0BAA\u200D",
        "\u0BAA\u0BCD{2}" : "\u0BAA\u0BCD\u0BAA\u200C",
        "\u0BAE\u200Ck" : "\u0BAE\u0BCD\u0BAE\u200D",
        "\u0BAE\u0BCD{2}" : "\u0BAE\u0BCD\u0BAE\u200C",
        "\u0BA4\u200Cl" : "\u0BA4\u0BCD\u0BA4\u200D",
        "\u0BA4\u0BCD{2}" : "\u0BA4\u0BCD\u0BA4\u200C",
        "\u0BA8\u200C," : "\u0BA8\u0BCD\u0BA8\u200D",
        "\u0BA8\u0BCD{2}" : "\u0BA8\u0BCD\u0BA8\u200C",
        "\u0BAF\u200C\'" : "\u0BAF\u0BCD\u0BAF\u200D",
        "\u0BAF\u0BCD{2}" : "\u0BAF\u0BCD\u0BAF\u200C",
        "\u0BB5\u200Cv" : "\u0BB5\u0BCD\u0BB5\u200D",
        "\u0BB5\u0BCD{2}" : "\u0BB5\u0BCD\u0BB5\u200C",
        "\u0B99\u200Cb" : "\u0B99\u0BCD\u0B99\u200D",
        "\u0B99\u0BCD{2}" : "\u0B99\u0BCD\u0B99\u200C",
        "\u0BB2\u200Cn" : "\u0BB2\u0BCD\u0BB2\u200D",
        "\u0BB2\u0BCD{2}" : "\u0BB2\u0BCD\u0BB2\u200C",
        "\u0BB0\u200Cm" : "\u0BB0\u0BCD\u0BB0\u200D",
        "\u0BB0\u0BCD{2}" : "\u0BB0\u0BCD\u0BB0\u200C",
        "\u0BB4\u200C/" : "\u0BB4\u0BCD\u0BB4\u200D",
        "\u0BB4\u0BCD{2}" : "\u0BB4\u0BCD\u0BB4\u200C",
        "\u0BB8\u200CQ" : "\u0BB8\u0BCD\u0BB8\u200D",
        "\u0BB8\u0BCD{2}" : "\u0BB8\u0BCD\u0BB8\u200C",
        "\u0BB7\u200CW" : "\u0BB7\u0BCD\u0BB7\u200D",
        "\u0BB7\u0BCD{2}" : "\u0BB7\u0BCD\u0BB7\u200C",
        "\u0B9C\u200CE" : "\u0B9C\u0BCD\u0B9C\u200D",
        "\u0B9C\u0BCD{2}" : "\u0B9C\u0BCD\u0B9C\u200C",
        "\u0BB9\u200CR" : "\u0BB9\u0BCD\u0BB9\u200D",
        "\u0BB9\u0BCD{2}" : "\u0BB9\u0BCD\u0BB9\u200C",
        "[\u200D|\u200C]q" : "\u0BBE",
        "[\u200D|\u200C]w" : "\u0BC0",
        "[\u200D|\u200C]e" : "\u0BC2",
        "[\u200D|\u200C]r" : "\u0BC8",
        "[\u200D|\u200C]t" : "\u0BC7",
        "\u0BCDa" : "\u200C",
        "[\u200D|\u200C]a" : "",
        "[\u200D|\u200C]s" : "\u0BBF",
        "[\u200D|\u200C]d" : "\u0BC1",
        "[\u200D|\u200C]f" : "\u0BCD",
        "[\u200D|\u200C]g" : "\u0BC6",
        "[\u200D|\u200C]z" : "\u0BCC",
        "[\u200D|\u200C]x" : "\u0BCB",
        "[\u200D|\u200C]c" : "\u0BCA",
        "\u200Cc" : "\u00A9",
        "\u200C\\." : "\u2022",
        "q" : "\u0B86",
        "w" : "\u0B88",
        "e" : "\u0B8A",
        "r" : "\u0B90",
        "t" : "\u0B8F",
        "a" : "\u0B85",
        "s" : "\u0B87",
        "d" : "\u0B89",
        "f" : "\u0B83",
        "F" : "\u0B83",
        "g" : "\u0B8E",
        "z" : "\u0B94",
        "x" : "\u0B93",
        "c" : "\u0B92",
        "Q" : "\u0BB8\u200C",
        "W" : "\u0BB7\u200C",
        "E" : "\u0B9C\u200C",
        "R" : "\u0BB9\u200C",
        "T" : "\u0B95\u0BCD\u0BB7\u200C",
        "Y" : "\u0BB8\u0BCD\u0BB0\u0BC0",
        "O" : "[",
        "P" : "]",
        "y" : "\u0BB3\u200C",
        "u" : "\u0BB1\u200C",
        "i" : "\u0BA9\u200C",
        "p" : "\u0BA3\u200C",
        "o" : "\u0B9F\u200C",
        "\\[" : "\u0B9A\u200C",
        "\\]" : "\u0B9E\u200C",
        "g" : "\u0B8E",
        "h" : "\u0B95\u200C",
        "j" : "\u0BAA\u200C",
        "k" : "\u0BAE\u200C",
        "l" : "\u0BA4\u200C",
        "," : "\u0BA8\u200C",
        "\'" : "\u0BAF\u200C",
        "v" : "\u0BB5\u200C",
        "b" : "\u0B99\u200C",
        "n" : "\u0BB2\u200C",
        "m" : "\u0BB0\u200C",
        "/" : "\u0BB4\u200C",
        "M" : "/",
        "A" : "\u0BF9",
        "S" : "\u0BFA",
        "D" : "\u0BF8",
        "K" : "\"",
        "L" : ":",
        "\\:" : ",",
        "\"" : "\'",
        "Z" : "\u0BF3",
        "X" : "\u0BF4",
        "C" : "\u0BF5",
        "V" : "\u0BF6",
        "B" : "\u0BF7",
        '(.+)\u200C(.+)' : "$1$2"
      }
    }
  }
}